image: docker:stable

stages:
  - build
  - test
  - package
  - migrate
  - deploy
  - rollback

services:
  - docker:dind

cache:
  paths:
    - node_modules/

build_app:
  stage: build
  image: node:14-alpine
  script:
    - npm ci
  artifacts:
    paths:
      - node_modules/
    expire_in: 1 day

test:
  stage: test
  image: node:14-alpine
  script:
    - npm run test

build docker image:
  stage: package
  image: docker
  services: 
    - docker:dind
  variables:
    DOCKER_DRIVER: overlay2
    CONTAINER_REGISTRY: "gcr.io"
    PROJECT_ID: "menucloud-address"
    GCR_REPOSITORY: "poc-nestjs-pg-typeorm"
    IMAGE_NAME: "poc-nestjs-pg-typeorm"
    IMAGE_TAG: "latest"
  script: 
    # Install CA certs, openssl to https downloads, python for gcloud sdk
    - apk add --update ca-certificates openssl python3 curl bash
    - update-ca-certificates

    # Download and install Google Cloud SDK
    - curl -sSL https://sdk.cloud.google.com | bash
    - export PATH=$PATH:/root/google-cloud-sdk/bin
    - gcloud --quiet components update
    - gcloud components install beta

    # Authenticate with Google Cloud
    - echo $SERVICE_ACCOUNT > /tmp/$CI_PIPELINE_ID.json
    - gcloud auth activate-service-account --key-file /tmp/$CI_PIPELINE_ID.json
    - gcloud auth configure-docker
    - gcloud config set project $PROJECT_ID
    - gcloud auth list


    # Build and push Docker image
    - docker build -t ${CONTAINER_REGISTRY}/${PROJECT_ID}/${GCR_REPOSITORY}:${IMAGE_TAG} .
    - docker push ${CONTAINER_REGISTRY}/${PROJECT_ID}/${GCR_REPOSITORY}:${IMAGE_TAG}

       
migrate:
  stage: migrate
  image: google/cloud-sdk:alpine
  services: 
    - docker:dind
  environment:
    name: migration
  variables:
    IMAGE_TAG: $CI_REGISTRY_IMAGE:$CI_COMMIT_REF_SLUG
  script:
    # Instalar Node.js y npm
    - apk add --update nodejs npm

    - echo $SERVICE_ACCOUNT > /tmp/$CI_PIPELINE_ID.json
    - gcloud auth activate-service-account --key-file /tmp/$CI_PIPELINE_ID.json
    - gcloud sql instances describe $INSTANCE_CONNECTION_NAME --project $PROJECT_ID

    - echo "Descargando cloud_sql_proxy..."
    - wget https://dl.google.com/cloudsql/cloud_sql_proxy.linux.amd64 -O cloud_sql_proxy
    - chmod +x cloud_sql_proxy

    # Iniciar Cloud SQL Proxy
    - echo "Iniciando Cloud SQL Proxy..."
    - ./cloud_sql_proxy -instances=$CONNECTION_NAME=tcp:0.0.0.0:5432&
    - sleep 4

    # Aplicar migraciones a la base de datos
    - echo "Aplicando migraciones a la base de datos ok..."

    - npm install -g typeorm rimraf nestjs
    - npm run migration:run
    - echo "MIGRATION_APPLIED=true" >> build.env

    # Detener Cloud SQL Proxy
    - echo "Deteniendo Cloud SQL Proxy..."
    - pkill cloud_sql_proxy
  artifacts:
    reports:
      dotenv: build.env

deploy:
  stage: deploy
  image: google/cloud-sdk
  environment:
    name: production
  script:
    - echo "Implement your deployment script here."
  only:
    - main
  needs:
    - migrate
 
rollback:
  stage: rollback
  image: google/cloud-sdk:alpine
  environment:
    name: production
  script:
    - |
      if [ "$MIGRATION_APPLIED" == "true" ]; then
        apk add --update nodejs npm

        echo $SERVICE_ACCOUNT > /tmp/$CI_PIPELINE_ID.json
        gcloud auth activate-service-account --key-file /tmp/$CI_PIPELINE_ID.json

        echo "Descargando cloud_sql_proxy..."
        wget https://dl.google.com/cloudsql/cloud_sql_proxy.linux.amd64 -O cloud_sql_proxy
        chmod +x cloud_sql_proxy

        echo "Iniciando Cloud SQL Proxy..."
        ./cloud_sql_proxy -instances=$CONNECTION_NAME=tcp:0.0.0.0:5432&
        sleep 4

        echo "Revertiendo las migraciones de la base de datos..."
        npm install -g typeorm
        npm run migration:revert

        echo "Deteniendo Cloud SQL Proxy..."
        pkill cloud_sql_proxy
      else
        echo "No se aplicó ninguna migración en esta ejecución del pipeline. No se realizará el rollback."
      fi
  needs:
    - deploy
